# requiring the environment of NodeJS 10
image: registry.gitlab.com/publicagilefactory/handbook/node:10

# add 'node_modules' to cache for speeding up builds
cache:
  key: "share-between-branches"
  paths:
    - node_modules/
    - public/
    - book_pdf/  
      # Node modules and dependencies

stages:
  - deploy
  - pdf

before_script:
  - npm install # install all dependencies listed in package.json


# the 'pages' job will deploy and build your site to the 'public' path
pages:
  stage: deploy
  script:
    - | 
      if [[ $CI_COMMIT_REF_NAME == 'master'  ]]
      then 
        mkdir -p public
        rm -rf public/*
        npm run build 
        mv -v ./_book/* public # move compiled book contents to the public path 
        rm -rf ./_book
      else 
        mkdir -p public/$CI_COMMIT_REF_NAME 
        rm -rf public/$CI_COMMIT_REF_NAME/*
        npm run build 
        mv -v ./_book/* public/$CI_COMMIT_REF_NAME # move compiled book contents to the public path  
        rm -rf ./_book
      fi
    - |
      if [[ -n "$CI_MERGE_REQUEST_IID" ]]
      then
        curl -vvvv -L -X POST --header "Private-Token: $AGILELAB_BOT" --data-urlencode "body=Your merge request has been rendered and can be reviewed at https://publicagilefactory.gitlab.io/handbook/$CI_COMMIT_REF_NAME/" https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/merge_requests/$CI_MERGE_REQUEST_IID/notes
      else
        true
      fi
  artifacts:
    paths:
      - public
  only:
    - merge_requests
    - master

# the 'create_pdf' job will create a pdf document of the repository on 'book_pdf' path
create_pdf:
  # Based on honkit image to get dependencies for pdf creation with calibre.
  image: honkit/honkit:v5.1.4
  stage: pdf
  script:
    - | 
      mkdir -p book_pdf
      rm -rf book_pdf/*
      sed -i '/"pagefooter",/d' book.json     # To remove footer with agile information from pdf file
      node ./scripts/createPDFCover.js "$CI_COMMIT_MESSAGE" # write commit message in pdf cover
      npx honkit pdf . handbook.pdf
      mv -v handbook.pdf book_pdf/  # move pdf file book to the book_pdf path 
  artifacts:
    paths:
      - book_pdf
  only:
    - merge_requests
    - master

